import nextcord, datetime, json, re, httpx, certifi
from nextcord.ext import commands
from colorama import Back, Fore, Style
from datetime import datetime, timedelta
import platform
import discord
import os


avatarbot = "https://cdn.discordapp.com/attachments/1187996016591507477/1193534450357776484/vecteezy_discord-logo-png-discord-icon-transparent-png_18930680_825.webp?ex=65ad1093&is=659a9b93&hm=af0b44f34612c4a7f9a7ea858849d5ff0414d09af9efcc2aa735098ec7d140ab&"
utc_now = datetime.utcnow()
# Add the desired timezone offset (in this case, +7 hours)
timezone_offset = timedelta(hours=7)
local_time = utc_now + timezone_offset
Alert = "⚠️ คุณไม่มีสิทธิ์ในการใช้คำสั่งนี้ !"
formatted_time = local_time.strftime("%Y-%m-%d %H:%M:%S")
SAVEROLES_LOG = 1261618525609525299
REVIEW_LOG = 1261618541929697351
class save_roles(discord.ui.View):
    def __init__(self) -> None:
        super().__init__(timeout=None)
        self.value = None
        self.cooldown = commands.CooldownMapping.from_cooldown(1, 6000, commands.BucketType.user)
        
config = json.load(open('./config.json', 'r', encoding='utf-8'))

bot = commands.Bot(
    command_prefix='nyx!',
    help_command=None,
    intents=nextcord.Intents.all(),
    strip_after_prefix=True,
    case_insensitive=True
)

class topupModal(nextcord.ui.Modal):

    def __init__(self):
        super().__init__(title='เติมเงิน', timeout=None, custom_id='topup-modal')
        self.link = nextcord.ui.TextInput(
            label = 'ลิ้งค์ซองอังเปา',
            placeholder = 'https://gift.truemoney.com/campaign/?v=xxxxxxxxxxxxxxx',
            style = nextcord.TextInputStyle.short,
            required = True
        )
        self.add_item(self.link)

    async def callback(self, interaction: nextcord.Interaction):
        link = str(self.link.value).replace(' ', '')
        message = await interaction.response.send_message(content='checking.', ephemeral=True)
        if re.match(r'https:\/\/gift\.truemoney\.com\/campaign\/\?v=+[a-zA-Z0-9]{18}', link):
            voucher_hash = link.split('?v=')[1]
            response = httpx.post(
                url = f'https://gift.truemoney.com/campaign/vouchers/{voucher_hash}/redeem',
                headers = {
                    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/8a0.0.3987.149 Safari/537.36'
                },
                json = {
                    'mobile': config['phoneNumber'],
                    'voucher_hash': f'{voucher_hash}'
                },
                verify=certifi.where(),
            )
            if (response.status_code == 200 and response.json()['status']['code'] == 'SUCCESS'):
                data = response.json()
                amount = int(float(data['data']['my_ticket']['amount_baht']))
                userJSON = json.load(open('./database/users.json', 'r', encoding='utf-8'))
                if (str(interaction.user.id) not in userJSON):
                    userJSON[str(interaction.user.id)] = {
                        "userId": interaction.user.id,
                        "point": amount,
                        "all-point": amount,
                        "transaction": [
                            {
                                "topup": {
                                    "url": link,
                                    "amount": amount,
                                    "time": str(datetime.datetime.now())
                                }
                            }
                        ]
                    }
                else:
                    userJSON[str(interaction.user.id)]['point'] += amount
                    userJSON[str(interaction.user.id)]['all-point'] += amount
                    userJSON[str(interaction.user.id)]['transaction'].append({
                        "topup": {
                            "url": link,
                            "amount": amount,
                            "time": str(datetime.datetime.now())
                        }
                    })
                json.dump(userJSON, open('./database/users.json', 'w', encoding='utf-8'), indent=4, ensure_ascii=False)
                embed = nextcord.Embed(description='✅﹒**เติมเงินสำเร็จ**', color=nextcord.Color.green())
            else:
                embed = nextcord.Embed(description='❌﹒**เติมเงินไม่สำเร็จ**', color=nextcord.Color.red())
        else:
            embed = nextcord.Embed(description='⚠﹒**รูปแบบลิ้งค์ไม่ถูกต้อง**', color=nextcord.Color.red())
        await message.edit(content=None,embed=embed)

class sellroleView(nextcord.ui.View):

    def __init__(self, message: nextcord.Message, value: str):
        super().__init__(timeout=None)
        self.message = message
        self.value = value

    @nextcord.ui.button(
        label='✅﹒ยืนยัน',
        custom_id='already',
        style=nextcord.ButtonStyle.primary,
        row=1
    )
    async def already(self, button: nextcord.Button, interaction: nextcord.Interaction):
        roleJSON = json.load(open('./database/roles.json', 'r', encoding='utf-8'))
        userJSON = json.load(open('./database/users.json', 'r', encoding='utf-8'))
        if (str(interaction.user.id) not in userJSON):
            embed = nextcord.Embed(description='🏦﹒เติมเงินเพื่อเปิดบัญชี', color=nextcord.Color.red())
        else:
            if (userJSON[str(interaction.user.id)]['point'] >= roleJSON[self.value]['price']):
                userJSON[str(interaction.user.id)]['point'] -= roleJSON[self.value]['price']
                userJSON[str(interaction.user.id)]['transaction'].append({
                    "payment": {
                        "roleId": self.value,
                        "time": str(datetime.datetime.now())
                    }
                })
                json.dump(userJSON, open('./database/users.json', 'w', encoding='utf-8'), indent=4, ensure_ascii=False)
                if ('package' in self.value):
                    for roleId in roleJSON[self.value]['roleIds']:
                        try:
                            await interaction.user.add_roles(nextcord.utils.get(interaction.user.guild.roles, id = roleId))
                        except:
                            pass
                    channelLog = bot.get_channel(config['channelLog'])
                    if (channelLog):
                        embed = nextcord.Embed()
                        embed.set_thumbnail(url=interaction.user.avatar.url)
                        embed.title = '»»———　ประวัติการซื้อยศ　——-««<'
                        embed.description = f'''
                       ﹒𝐔𝐬𝐞𝐫 : **<@{interaction.user.id}>**
                       ﹒𝐍𝐚𝐦𝐞 : **{interaction.user.name}**
                       ﹒𝐏𝐫𝐢𝐜𝐞 : **{roleJSON[self.value]['price']}**𝐓𝐇𝐁
                       ﹒𝐆𝐞𝐭𝐑𝐨𝐥𝐞 : <@&{roleJSON[self.value]["roleId"]}>
                       »»———　FLEXZY STORE　——-««<'''
                        embed.color = nextcord.Color.blue()
                        embed.set_footer(text='FLEXZY STORE AUTO BUY ROLE', icon_url='https://cdn.discordapp.com/attachments/1105860649294237846/1168953031904215132/FLEXZYLogo_2.gif?ex=6553a358&is=65412e58&hm=0e9231fb6f50546e05140ba1f1ef61cf100f221f613b8695feb9d3fd8f01879f&')
                        await channelLog.send(embed=embed)
                    embed = nextcord.Embed(description=f'💲﹒ซื้อยศสำเร็จ ได้รับ <@&{roleJSON[self.value]["name"]}>', color=nextcord.Color.green())
                else:
                    channelLog = bot.get_channel(config['channelLog'])
                    if (channelLog):
                        embed = nextcord.Embed()
                        embed.set_thumbnail(url=interaction.user.avatar.url)
                        embed.title = '»»———　ประวัติการซื้อยศ　——-««<'
                        embed.description = f'''
                       ﹒𝐔𝐬𝐞𝐫 : **<@{interaction.user.id}>**
                       ﹒𝐍𝐚𝐦𝐞 : **{interaction.user.name}**
                       ﹒𝐏𝐫𝐢𝐜𝐞 : **{roleJSON[self.value]['price']}**𝐓𝐇𝐁
                       ﹒𝐆𝐞𝐭𝐑𝐨𝐥𝐞 : <@&{roleJSON[self.value]["roleId"]}>
                       »»———　FLEXZY STORE　——-««<'''
                        embed.color = nextcord.Color.blue()
                        embed.set_footer(text='FLEXZY STORE AUTO BUY ROLE', icon_url='https://cdn.discordapp.com/attachments/1105860649294237846/1168953031904215132/FLEXZYLogo_2.gif?ex=6553a358&is=65412e58&hm=0e9231fb6f50546e05140ba1f1ef61cf100f221f613b8695feb9d3fd8f01879f&')
                        await channelLog.send(embed=embed)
                    embed = nextcord.Embed(description=f'💲﹒ซื้อยศสำเร็จ ได้รับยศ <@&{roleJSON[self.value]["roleId"]}>', color=nextcord.Color.green())
                    role = nextcord.utils.get(interaction.user.guild.roles, id = roleJSON[self.value]['roleId'])
                    await interaction.user.add_roles(role)
            else:
                embed = nextcord.Embed(description=f'⚠﹒เงินของท่านไม่เพียงพอ ขาดอีก ({roleJSON[self.value]["price"] - userJSON[str(interaction.user.id)]["point"]})', color=nextcord.Color.red())
        return await self.message.edit(embed=embed, view=None, content=None)

    @nextcord.ui.button(
        label='❌﹒ยกเลิก',
        custom_id='cancel',
        style=nextcord.ButtonStyle.red,
        row=1
    )
    async def cancel(self, button: nextcord.Button, interaction: nextcord.Interaction):
        return await self.message.edit(content='💚﹒ยกเลิกสำเร็จ',embed=None, view=None)

class sellroleSelect(nextcord.ui.Select):

    def __init__(self):
        options = []
        roleJSON = json.load(open('./database/roles.json', 'r', encoding='utf-8'))
        for role in roleJSON:
            options.append(nextcord.SelectOption(
                label=roleJSON[role]['name'],
                description=roleJSON[role]['description'],
                value=role,
                emoji=roleJSON[role]['emoji']
            ))
        super().__init__(
            custom_id='select-role',
            placeholder='[ เลือกยศที่คุณต้องการซื้อ ]',
            min_values=1,
            max_values=1,
            options=options,
            row=0
        )
    async def callback(self, interaction: nextcord.Interaction):
        message = await interaction.response.send_message(content='[SELECT] กำลังตรวจสอบ', ephemeral=True)
        selected = self.values[0]
        if ('package' in selected):
            roleJSON = json.load(open('./database/roles.json', 'r', encoding='utf-8'))
            embed = nextcord.Embed()
            embed.description = f'''
E {roleJSON[selected]['name']}**
'''
            await message.edit(content=None,embed=embed,view=sellroleView(message=message, value=selected))
        else:
            roleJSON = json.load(open('./database/roles.json', 'r', encoding='utf-8'))
            embed = nextcord.Embed()
            embed.title = '»»———　ยืนยันการสั่งซื้อ　——-««'
            embed.description = f'''
           \n คุณแน่ใจหรอที่จะซื้อ <@&{roleJSON[selected]['roleId']}> \n
»»———　FLEXZY STORE　——-««
'''
            embed.color = nextcord.Color.blue()
            embed.set_thumbnail(url='https://media.discordapp.net/attachments/1105860649294237846/1119141652733374574/Logo2.png?width=676&height=676')
            await message.edit(content=None,embed=embed,view=sellroleView(message=message, value=selected))

class setupView(nextcord.ui.View):

    def __init__(self):
        super().__init__(timeout=None)
        self.add_item(sellroleSelect())

    @nextcord.ui.button(
        label='🧧﹒เติมเงิน',
        custom_id='topup',
        style=nextcord.ButtonStyle.primary,
        row=1
    )
    async def topup(self, button: nextcord.Button, interaction: nextcord.Interaction):
        await interaction.response.send_modal(topupModal())
        
        
    @nextcord.ui.button(
        label='💳﹒เช็คเงิน',
        custom_id='balance',
        style=nextcord.ButtonStyle.primary,
        row=1
    )


    async def save_roles1(self, interaction: discord.Interaction, button: discord.ui.Button):
      bucket = self.cooldown.get_bucket(interaction.message)
      retry_after = bucket.update_rate_limit()
      if retry_after:
            # ถ้าอยู่ใน Cooldown ให้ส่งข้อความไปยังผู้ใช้
            await interaction.response.send_message(f"> 📊 ท่านสามารถกดได้อีกรอบใน {round(retry_after, 1)} วินาที !!", ephemeral=True)
      else:
        user = interaction.user
        role_data = [role.name for role in user.roles if "@everyone" not in role.name]
        file_path = f"saveroles/role_{user.name}.json"

        try:
            with open(file_path, "w") as f:
                json.dump(role_data, f)
        except Exception as e:
            print(f"Error saving roles: {e}")
            await interaction.response.send_message("An error occurred while saving roles.", ephemeral=True)
            return
    @discord.ui.button(
         label= '🌻﹒เชฟยศ', 
         custom_id='save_rolesui2',
         style=discord.ButtonStyle.green,
         row=1
    )
    

    
    async def save_roles2(self, interaction: discord.Interaction, button: discord.ui.Button):    
        user = interaction.user
        file_path = f"saveroles/role_{user.name}.json"
        try:
            with open(file_path, "r") as f:
                role_data = json.load(f)
                for role_name in role_data:
                    roles = discord.utils.get(interaction.guild.roles, name=role_name)
                    await user.add_roles(roles)
            await interaction.response.send_message("```diff\n+ คืนยศให้คุณเรียบร้อยแล้ว\n```", ephemeral=True)
        except FileNotFoundError:
            await interaction.response.send_message("```diff\n- ขออภัยไม่มีขอมูลของคุณ```", ephemeral=True)

    @discord.ui.button(
        label= '🤍﹒รับยศคืน', 
         custom_id='save_rolesui1',
         style=discord.ButtonStyle.primary,
         row=1
    )
    
    async def save_roles3(self, interaction: discord.Interaction, button: discord.ui.Button): 
        user = interaction.user

        created_since = (interaction.message.created_at - user.created_at).days
        created_since_str = f"{created_since} วันที่ผ่านมา"

        user_info_embed = discord.Embed(title=f"ข้อมูลของ {user.display_name}", color=discord.Color.blurple())

        if user.avatar:
            user_info_embed.set_thumbnail(url=user.avatar.url)
        else:
            user_info_embed.set_thumbnail(url="file:///C:/Users/User/Downloads/726703ed24cb298eddd25ee9f8da00db.gif")

        user_info_embed.add_field(name="ID Discord", value=user.id, inline=False)
        user_info_embed.add_field(name="วันที่สร้างบัญชี", value=created_since_str, inline=False)

        if len(user.roles) > 1:
            roles = ", ".join([role.mention for role in user.roles[1:]])
            user_info_embed.add_field(name="บทบาท", value=roles, inline=False)

        if user.premium_since:
            user_info_embed.add_field(name="Nitro Boost", value="เป็น Nitro Boost ตั้งแต่: " + user.premium_since.strftime("%Y-%m-%d"), inline=False)

    @discord.ui.button(
        label="🍇﹒ดูข้อมูลผู้ใช้",
        custom_id='save_rolesui3',
        style=discord.ButtonStyle.red, 
        row=2
   )

    async def balance(self, button: nextcord.Button, interaction: nextcord.Interaction):
        userJSON = json.load(open('./database/users.json', 'r', encoding='utf-8'))        
        if (str(interaction.user.id) not in userJSON):
            embed = nextcord.Embed(description='🏦﹒เติมเงินเพื่อเปิดบัญชี', color=nextcord.Color.red())
        else:
            embed = nextcord.Embed(description=f'╔═══════▣◎▣═══════╗\n\n💳﹒ยอดเงินคงเหลือ **__{userJSON[str(interaction.user.id)]["point"]}__** บาท\n\n╚═══════▣◎▣═══════╝', color=nextcord.Color.green())
        return await interaction.response.send_message(embed=embed, ephemeral=True)

@bot.event
async def on_ready():
    bot.add_view(setupView())
    print(f'LOGIN AS {bot.user}')

@bot.slash_command(
    name='setup',
    description='setup',
    guild_ids=[config['serverId']]
)

async def setup(interaction: nextcord.Interaction):
    if (interaction.user.id not in config['ownerIds']):
        return await interaction.response.send_message(content='[ERROR] No Permission For Use This Command.', ephemeral=True)
    embed = nextcord.Embed()
    embed.title = '───         บอทซื้อยศ 24 ชั่วโมง         ───'
    embed = discord.Embed()
    embed.set_author(name="บอทซื้อยศ 24 ชั่วโมง", url="", icon_url=avatarbot)
    embed.add_field(name="`🟢` บอทซื้อยศ 24 ชั่วโมง `🟢`", value="```diff\n🎐 : ซื้อยศอัตโนมัตผ่านบอท ยศทุกอย่างซื้อแล้วคุ้มค่าแน่นอน 🎁 : สนับสนุนร้านนี้ไม่มีผิดหวังแจกของเรื่อยๆไม่มีซึมจ้า\n```", inline=True)
    embed.add_field(name="`🟢` วิธีการเติมงาน `🟢`", value="```diff\n+ ให้กดปุ่ม (เตืมงาน) เพื่อทำการเติมงาน\n+เติมเงินด้วยระบบอั่งเปา\n+ ระบบออโต้ 24 ชั่วโมง ```", inline=True)
    embed.add_field(name="`❗` ข้อความจากแอดมิน `❗`", value="```diff\n- ❗ : บอทมีปัญหาโปรดแจ้งแอดมินโดยทันที\n+ 💳﹒เติมเงินด้วยระบบอั่งเปา\n+ ✨﹒ระบบออโต้ 24 ชั่วโมง\n+ 💲﹒ซื้อแล้วได้ยศเลย\n+ 🔓﹒เติมเงินเพื่อเปิดบัญชี```", inline=False)
    embed.set_image(url="https://media.discordapp.net/attachments/1248803700890144788/1261598898703568948/befa8c17-29e4-42ba-86a0-3fa1e0ebcabc.jpg?ex=66938b08&is=66923988&hm=d8688828ab4b0bbe3ff12745462ad884118e32ad78a16e3cb06add7217439f3d&=&format=webp&width=419&height=419")
    embed.set_image(url="https://images-ext-1.discordapp.net/external/JDnpFIEpRqs3lXwgtc6zk023mQP0KD5GDkXbRbWkAUM/https/www.checkraka.com/uploaded/img/content/130026/aungpao_truewallet_01.jpg")
    await interaction.channel.send(embed=embed, view=setupView())
    await interaction.response.send_message(content='[SUCCESS] Done.', ephemeral=True)
bot.run(config['token'])